﻿using Android.OS;
using Android.Views;
using BeSafePlus.Services;

namespace BeSafePlus.Platforms.Android.UI
{
    public class UIService : IUIService
    {
        public void ApplyTheme(bool isDarkMode)
        {
            var activity = Platform.CurrentActivity;

            var window = activity?.Window;

            var black = global::Android.Graphics.Color.Black;

            var white = global::Android.Graphics.Color.ParseColor("#F3F6F4");

            if (window != null && Build.VERSION.SdkInt >= BuildVersionCodes.Lollipop)
            {
                var navColor = isDarkMode ?  black : white;

                var statusColor = isDarkMode ? black : white;

                window.SetNavigationBarColor(navColor);

                window.SetStatusBarColor(statusColor);

                if (Build.VERSION.SdkInt >= BuildVersionCodes.R)
                {
                    var insetsController = window.InsetsController;

                    if (insetsController != null)
                    {
                        insetsController.SetSystemBarsAppearance(
                            isDarkMode ? 0 : (int)WindowInsetsControllerAppearance.LightNavigationBars,
                            (int)WindowInsetsControllerAppearance.LightNavigationBars
                        );
                    }
                }
            }
        }
    }
}